//
//  exercise2.cpp
//  Session 6
//
//  Created by Luis Angel on 5/7/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

// Constant (global) definitions.
const int STUDENTS = 3;
const int EXAMS = 4;

// Function prototypes.
int minimum( const int a[][EXAMS], int pupils, int tests );
int maximum( const int a[][EXAMS], int pupils, int tests );
double average( const int a[], int tests );

int main2(int argc, const char * argv[])
{
	// Declaring grades 2D array.
	const int grades[STUDENTS][EXAMS] = { { 77, 68, 86, 73 },
		{ 96, 87, 89, 78 },
		{ 70, 90, 86, 81 } };
	
	// Finding the lowest grade.
	cout << "The lowest grade is " << minimum( grades, STUDENTS, EXAMS ) << endl;
	
	// Finding the highest grade.
	cout << "The highest grade is " << maximum( grades, STUDENTS, EXAMS ) << endl;
	
	// Finding the average grade per student.
	for( int r = 0; r < STUDENTS; r++ )				// Select a student.
		cout << "Student " << r << "'s average is " << average( grades[r], EXAMS ) << endl;
	
	return 0;
}

/*
 * Find the lowest grade in 2D array a.
 */
int minimum( const int a[][EXAMS], int pupils, int tests )
{
	int lowest = 100;
	for( int r = 0; r < pupils; r++ )				// Select a student.
	{
		for( int c = 0; c < tests; c++ )			// Check exams for given student.
		{
			if( a[r][c] < lowest )					// Is this student's grade on c-th exam lower than lowest so far?
				lowest = a[r][c];
		}
	}
	
	return lowest;
}

/*
 * Find the highest grade in 2D array a.
 */
int maximum( const int a[][EXAMS], int pupils, int tests )
{
	int highest = 0;
	for( int r = 0; r < pupils; r++ )				// Select a student.
	{
		for( int c = 0; c < tests; c++ )			// Check exams for given student.
		{
			if( a[r][c] > highest )					// Is this student's grade on c-th exam higher than higest so far?
				highest = a[r][c];
		}
	}
	
	return highest;
}

/*
 * Compute the average for given student exam grades.
 */
double average( const int a[], int tests )
{
	if( tests == 0 )
		return 0.0;
	
	double sum = 0;
	for( int t = 0; t < tests; t++ )
		sum += a[t];								// Accumulate all exam grades for this student.
	
	return sum/tests;
}




